--- Smac/smacXcoral.c	2006-10-16 16:25:44.000000000 -0400
+++ Smac/smacXcoral.c	2014-12-27 22:32:15.000000000 -0500
@@ -1278,14 +1160,13 @@ Object builtin_current_window(a)
 }
 
-Object builtin_select_window(a)
+static Object builtin_select_window(a)
     Instruction ** a;
 {
-  extern FCT(char *, ie_select_window,(char *, int));
   int win = Eval(*a);
-  char * selectedwindow;
+  Text * selectedwindow;
   int result;
-  
+
   ignore_ctrl_c();
-  selectedwindow = ie_select_window(i_buffer_courant, win);
+  selectedwindow = ie_select_window(win);
   if (selectedwindow) {
     i_buffer_courant = selectedwindow;
@@ -1299,10 +1180,9 @@ Object builtin_select_window(a)
 }
 
-Object builtin_new_window(a)
-    Instruction ** a;
+static Object builtin_new_window(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_new_window,(char *));
   int result;
-  
+
   ignore_ctrl_c();
   result = ie_new_window(i_buffer_courant);
@@ -1312,10 +1192,9 @@ Object builtin_new_window(a)
 }
 
-Object builtin_kill_window(a)
+static Object builtin_kill_window(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_kill_window,(char *, int));
   int win = Eval(*a);
-  
+
   ignore_ctrl_c();
   ie_kill_window(i_buffer_courant, win);
@@ -1325,9 +1204,8 @@ Object builtin_kill_window(a)
 }
 
-Object builtin_kill_current_buffer(a)
-    Instruction ** a;
+static Object builtin_kill_current_buffer(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_kill_current_buffer,(char *));
-  
+
   ignore_ctrl_c();
   ie_kill_current_buffer(i_buffer_courant);
@@ -1337,9 +1215,8 @@ Object builtin_kill_current_buffer(a)
 }
 
-Object builtin_lower_window(a)
-    Instruction ** a;
+static Object builtin_lower_window(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_lower_window,(char *));
-  
+
   ignore_ctrl_c();
   ie_lower_window(i_buffer_courant);
@@ -1349,9 +1226,8 @@ Object builtin_lower_window(a)
 }
 
-Object builtin_raise_window(a)
-    Instruction ** a;
+static Object builtin_raise_window(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_raise_window,(char *));
-  
+
   ignore_ctrl_c();
   ie_raise_window(i_buffer_courant);
@@ -1364,12 +1240,11 @@ static Object builtin_wprintf(a)
      Instruction ** a;
 {
-  extern FCT(void, ie_insert_char,(char *, int));
   int result = 0;
-  char * fmt = (char *) Eval(*a);
+  char *fmt = (char *)Eval(*a);
 
 #ifdef RUNTIMECHECK
   check_strlen(fmt);
 #endif
-  
+
   a += 1;
 
@@ -1379,13 +1254,13 @@ static Object builtin_wprintf(a)
       case 0 :
 	return result;
-	
+
       case '%' :
 	ie_insert_char(i_buffer_courant, '%');
 	fmt += 1;
 	break;
-	
+
       default :
 	{
-	  char * begin = fmt - 1;
+	  const char * begin = fmt - 1;
 	  char save;
 
@@ -1419,5 +1294,5 @@ static Object builtin_wprintf(a)
 	    char str[128];
 	    char * s = str;
-	    
+
 	    sprintf(s, begin, Eval(*a));
 	    while (*s) ie_insert_char(i_buffer_courant, *s++);
@@ -1431,14 +1306,13 @@ static Object builtin_wprintf(a)
       ie_insert_char(i_buffer_courant, *fmt++);
   }
-  
+
   return result;
 }
 
-Object builtin_display_message(a)
+static Object builtin_display_message(a)
     Instruction ** a;
 {
-  extern FCT(void, DisplayWMessage ,(char *, char *, int));
-  
-  char * msg = (char *) Eval(a[0]);
+
+  const char *msg = (const char *)Eval(a[0]);
   char * from = "";
   int flag = 0;
@@ -1447,5 +1321,5 @@ Object builtin_display_message(a)
     check_strlen(msg);
 #endif
-  
+
   if (! IsaNotEnoughArg(a[1])) {
     from = (char *) Eval(a[1]);
@@ -1457,5 +1331,5 @@ Object builtin_display_message(a)
       flag = (int) Eval(a[2]);
   }
-  
+
   DisplayWMessage(msg, from, flag);
   return 0;
@@ -1465,35 +1339,28 @@ Object builtin_display_message(a)
 
 static char ** item_list;
-static item_list_size;
+static int item_list_size;
 static int n_item;
 
-Object builtin_select_from_list(a)
-    Instruction ** a;
+static Object builtin_select_from_list(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ClearListBox ,());
-  extern FCT(char *, FillList ,(char *));
-  extern FCT(char *, SelectFromListBox ,(char *));
-  char * str = (char *) Eval(*a);
+  const char *str;
 
-#ifdef RUNTIMECHECK
-  check_strlen(str);
-#endif
-  
   if (! n_item) return 0;
-  
+
   ClearListBox();
   {
     int i;
-    
+
     for (i = 0; i != n_item; i += 1)
       FillList(item_list[i]);
   }
-  
-  if (! (str = SelectFromListBox(str)))
+
+  if (! (str = SelectFromListBox()))
     return 0;
-  
+
   {
     char ** p = item_list;
-    
+
     while (
 #ifdef RUNTIMECHECK
@@ -1506,27 +1373,26 @@ Object builtin_select_from_list(a)
 }
 
-Object builtin_add_list_item(a)
+static Object builtin_add_list_item(a)
     Instruction ** a;
 {
-  extern FCT(char *, FillList ,(char *));
-  char * item = (char *) Eval(*a);
+  char *item = (char *)Eval(*a);
 
 #ifdef RUNTIMECHECK
   check_strlen(item);
 #endif
-  
+
   FillList(item);
   if (n_item == item_list_size) {
     if (! item_list_size) {
-      if (! (item_list = (char **) calloc(10, sizeof(char *))))
+      if (! (item_list = calloc(10, sizeof(char *))))
 	Error("No more place", 0);
       item_list_size = 10;
     }
     else {
-      char ** nl = (char **) calloc(2 * item_list_size, sizeof(char *));
-    
+      char ** nl = calloc(2 * item_list_size, sizeof(char *));
+
       if (! nl)
 	Error("No more place", 0);
-      memcpy((char *) nl, (char *) item_list, item_list_size * sizeof(char *));
+      memcpy(nl, item_list, item_list_size * sizeof(char *));
       free(item_list);
       item_list = nl;
@@ -1534,15 +1400,14 @@ Object builtin_add_list_item(a)
     }
   }
-  
+
   item_list[n_item++] = item;
-  
+
   return 0;
 }
 
-Object builtin_clear_list(a)
-    Instruction ** a;
+static Object builtin_clear_list(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ClearListBox ,());
-  
+
   ClearListBox();
   if (item_list) {
@@ -1556,42 +1421,40 @@ Object builtin_clear_list(a)
 /* */
 
-Object builtin_getchar(a)
+static Object builtin_getchar(a)
     Instruction ** a;
 {
-  char * prompt;
-    
-  extern FCT(char *, GetStringFromDB, (char * prompt, int one));
-  char * str;
-    
+  const char * prompt;
+
+  const char * str;
+
   if (IsaNotEnoughArg(*a))
     prompt = "getchar ? ";
   else {
     prompt = (char *) Eval(*a);
-    
+
 #ifdef RUNTIMECHECK
     check_strlen(prompt);
 #endif
   }
-  
+
   str = GetStringFromDB(prompt, 1);
   return (str) ? (Object) *str : (Object) 0;
 }
 
-Object builtin_gets(a)
+static Object builtin_gets(a)
     Instruction ** a;
 {
   char * prompt;
-  extern FCT(char *, GetStringFromDB, (char * prompt, int one));
-    
+
   if (IsaNotEnoughArg(*a))
     prompt = "gets ? ";
   else {
     prompt = (char *) Eval(*a);
-    
+
 #ifdef RUNTIMECHECK
     check_strlen(prompt);
 #endif
   }
-  
+
   return strdup_end(GetStringFromDB(prompt, 0));
 }
@@ -1601,31 +1464,28 @@ Object builtin_gets(a)
 /* coloriage */
 
-Object builtin_monochrome(a)
-     Instruction ** a;
+static Object builtin_monochrome(a)
+     Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_monochrome,(char *));
 
-  return ie_monochrome(i_buffer_courant);
+  return ie_monochrome();
 }
 
-Object builtin_remove_colors(a)
-     Instruction ** a;
+static Object builtin_remove_colors(a)
+     Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ie_remove_colors,(char *));
 
   ignore_ctrl_c();
   ie_remove_colors(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_color_area(a)
+static Object builtin_color_area(a)
      Instruction ** a;
 {
-  extern FCT(void, ie_color_area,(char *, int, int, char *));
   int start = (int) Eval(a[0]);
   int end = (int) Eval(a[1]);
-  char * color = (char *) Eval(a[2]);
+  const char *color = (const char *)Eval(a[2]);
 
 #ifdef RUNTIMECHECK
@@ -1636,12 +1496,11 @@ Object builtin_color_area(a)
   ie_color_area(i_buffer_courant, start, end, color);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_uncolor_area(a)
+static Object builtin_uncolor_area(a)
      Instruction ** a;
 {
-  extern FCT(void, ie_uncolor_area,(char *, int, int));
   int start = (int) Eval(a[0]);
   int end = (int) Eval(a[1]);
@@ -1650,12 +1509,11 @@ Object builtin_uncolor_area(a)
   ie_uncolor_area(i_buffer_courant, start, end);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_current_buffer_is_colored(a)
-     Instruction ** a;
+static Object builtin_current_buffer_is_colored(a)
+     Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_current_buffer_is_colored,(char *));
   Object result;
 
@@ -1663,5 +1521,5 @@ Object builtin_current_buffer_is_colored
   result = ie_current_buffer_is_colored(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
@@ -1670,8 +1528,7 @@ Object builtin_current_buffer_is_colored
 /* region */
 
-Object builtin_mark_position(a)
-     Instruction ** a;
+static Object builtin_mark_position(a)
+     Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_mark_position,(char *));
   Object result;
 
@@ -1679,78 +1536,72 @@ Object builtin_mark_position(a)
   result = ie_mark_position(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_set_mark(a)
+static Object builtin_set_mark(a)
      Instruction ** a;
 {
-  extern FCT(void, ie_set_mark,(char *, int));
   int pos = (int) Eval(*a);
-  
+
   ignore_ctrl_c();
   ie_set_mark(i_buffer_courant, pos);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_goto_mark(a)
-     Instruction ** a;
+static Object builtin_goto_mark(a)
+     Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ie_goto_mark,(char *));
 
   ignore_ctrl_c();
   ie_goto_mark(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_reset_mark(a)
-     Instruction ** a;
+static Object builtin_reset_mark(a)
+     Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ie_reset_mark,(char *));
 
   ignore_ctrl_c();
   ie_reset_mark(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_cut_region(a)
-     Instruction ** a;
+static Object builtin_cut_region(a)
+     Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ie_cut_region,(char *));
 
   ignore_ctrl_c();
   ie_cut_region(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_copy_region(a)
-     Instruction ** a;
+static Object builtin_copy_region(a)
+     Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ie_copy_region,(char *));
 
   ignore_ctrl_c();
   ie_copy_region(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_paste_region(a)
-     Instruction ** a;
+static Object builtin_paste_region(a)
+     Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ie_paste_region,(char *));
 
   ignore_ctrl_c();
   ie_paste_region(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return 0;
 }
@@ -1759,9 +1610,8 @@ Object builtin_paste_region(a)
 /* expression regulieres */
 
-Object builtin_re_search_forward(a)
+static Object builtin_re_search_forward(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_re_search_forward,(char*, char *regex ));
-  char * regex = (char *) Eval(*a);
+  const char *regex = (const char *)Eval(*a);
   int result;
 
@@ -1772,13 +1622,12 @@ Object builtin_re_search_forward(a)
   result = ie_re_search_forward(i_buffer_courant, regex);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_re_search_backward(a)
+static Object builtin_re_search_backward(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_re_search_backward,(char*, char * ));
-  char * regex = (char *) Eval(*a);
+  const char *regex = (const char *)Eval(*a);
   int result;
 
@@ -1789,27 +1638,25 @@ Object builtin_re_search_backward(a)
   result = ie_re_search_backward(i_buffer_courant, regex);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_re_replace(a)
+static Object builtin_re_replace(a)
     Instruction ** a;
 {
-  char * newstring = (char *) Eval(a[0]);
+  const char *newstring = (const char *)Eval(a[0]);
   int result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(newstring);
 #endif
   if (IsaNotEnoughArg(a[1])) {
-    extern FCT(int, ie_re_replace_match, (char *, char *));
-    
+
     ignore_ctrl_c();
     result = ie_re_replace_match(i_buffer_courant, newstring);
   }
   else {
-    extern FCT(int, ie_re_replace, (char *, char *, char*));
-    char * regex = (char *) Eval(a[1]);
-    
+    const char *regex = (const char *)Eval(a[1]);
+
 #ifdef RUNTIMECHECK
     check_strlen(regex);
@@ -1819,33 +1666,31 @@ Object builtin_re_replace(a)
   }
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_re_match_beginning(a)
+static Object builtin_re_match_beginning(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_re_match_beginning,(char *, int));
   int n = (int) Eval(*a);
   int result;
-  
+
   ignore_ctrl_c();
-  result = ie_re_match_beginning(i_buffer_courant, n);
+  result = ie_re_match_beginning(n);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_re_match_end(a)
+static Object builtin_re_match_end(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_re_match_end,(char *, int));
   int n = (int) Eval(*a);
   int result;
-  
+
   ignore_ctrl_c();
-  result = ie_re_match_end(i_buffer_courant, n);
+  result = ie_re_match_end(n);
   accept_ctrl_c();
-  
+
   return result;
 }
@@ -1853,39 +1698,36 @@ Object builtin_re_match_end(a)
 /* la montre*/
 
-Object builtin_watch_on(a)
-    Instruction ** a;
+static Object builtin_watch_on(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_watch_on,(char *));
-  
+
   ignore_ctrl_c();
   ie_watch_on(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_watch_off(a)
-    Instruction ** a;
+static Object builtin_watch_off(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_watch_off,(char *));
-  
+
   ignore_ctrl_c();
   ie_watch_off(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
 /* La fonction usleep */
-Object builtin_usleep(a)
+static Object builtin_usleep(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_usleep,(char *, int));
   int t = (int) Eval(*a);
-  
+
   ignore_ctrl_c();
-  ie_usleep(i_buffer_courant, t);
+  ie_usleep(t);
   accept_ctrl_c();
-  
+
   return 0;
 }
@@ -1896,13 +1738,14 @@ Object builtin_usleep(a)
 #include "../proc_dict.h"
 #include "../global_dict.h"
+#include "../browser_init.h"
+#include "../browser_eve.h"
 
 /* le browser */
 
-Object builtin_browser_set_pp(a)
+static Object builtin_browser_set_pp(a)
     Instruction ** a;
 {
-  extern FCT(void, browser_set_pp,(char *, char *));
-  char * mode = (char *) Eval(a[0]);
-  char * path = (char *) Eval(a[1]);
+  const char *mode = (const char *)Eval(a[0]);
+  const char *path = (const char *)Eval(a[1]);
 #ifdef RUNTIMECHECK
   check_strlen(mode);
@@ -1914,10 +1757,9 @@ Object builtin_browser_set_pp(a)
 }
 
-Object builtin_browser_set_pp_options(a)
+static Object builtin_browser_set_pp_options(a)
     Instruction ** a;
 {
-  extern FCT(void, browser_set_pp_options,(char *, char *));
-  char * mode = (char *) Eval(a[0]);
-  char * opt = (char *) Eval(a[1]);
+  const char *mode = (const char *)Eval(a[0]);
+  const char *opt = (const char *)Eval(a[1]);
 #ifdef RUNTIMECHECK
   check_strlen(mode);
@@ -1929,9 +1771,8 @@ Object builtin_browser_set_pp_options(a)
 }
 
-Object builtin_browser_add(a)
+static Object builtin_browser_add(a)
     Instruction ** a;
 {
-  extern FCT(void, browser_add,(char *, int));
-  char * file = (char *) Eval(a[0]);
+  const char *file = (const char *)Eval(a[0]);
 #ifdef RUNTIMECHECK
   check_strlen(file);
@@ -1943,8 +1784,7 @@ Object builtin_browser_add(a)
 }
 
-Object builtin_browser_del(a)
+static Object builtin_browser_del(a)
     Instruction ** a;
 {
-  extern FCT(void, RemoveFiles,(char *));
   char * file = (char *) ((IsaNotEnoughArg(a[1])) ? 0 : (char *) Eval(a[0]));
 #ifdef RUNTIMECHECK
@@ -1959,22 +1799,18 @@ Object builtin_browser_del(a)
 }
 
-Object builtin_browser_class_file(a)
+static Object builtin_browser_class_file(a)
     Instruction ** a;
 {
-  extern FCT(char *, browser_class_file,(char *, int *));
-  char * name = (char *) Eval(a[0]);
+  const char *name = (const char *)Eval(a[0]);
   int * p = (int *) ((IsaNotEnoughArg(a[1])) ? 0 : (int *) Eval(a[1]));
-  char * file;
+  const char * file;
   int line;
-  extern FCT(char *, browser_class_file,(char *, int *));
 #ifdef RUNTIMECHECK
-  extern FCT(Object, check_int_indirection_assignment,(int *, Object));
-  
   check_strlen(name);
 #endif
-  
+
   ignore_ctrl_c();
   file = browser_class_file(name, &line);
- 
+
   if (file) {
     if (p) {
@@ -1987,17 +1823,16 @@ Object builtin_browser_class_file(a)
     return strdup_end(file);
   }
-  
+
   accept_ctrl_c();
   return 0;
 }
 
-Object builtin_browser_class_parents(a)
+static Object builtin_browser_class_parents(a)
     Instruction ** a;
 {
-  FCT(extern ParentRec **, get_parents_list,(char *, int));
-  char * class_name = (char *) Eval(a[0]);
+  const char *class_name = (const char *)Eval(a[0]);
   ParentRec ** list;
-  char ** result = 0;
-  
+  char ** result = NULL;
+
 #ifdef RUNTIMECHECK
   check_strlen(class_name);
@@ -2005,19 +1840,19 @@ Object builtin_browser_class_parents(a)
 
   ignore_ctrl_c();
-  if ((list = get_parents_list(class_name, 1)) != 0) {
+  if ((list = get_parents_recs(class_name)) != 0) {
     unsigned nentry;
     unsigned names_size = 0;
-    
+
     for (nentry = 0; list[nentry]; nentry += 1)
       names_size += strlen(list[nentry]->_name) + 1;
-  
-    result = (char **) RTCMalloc(sizeof(char*) * (nentry * 2 + 1) + names_size);
-    
+
+    result = RTCMalloc(sizeof(char*) * (nentry * 2 + 1) + names_size);
+
     if (result) {
       char * p = (char *) &result[2 * nentry + 1];
       ParentRec ** l = list;
-      
+
       for (nentry = 0; *l; nentry += 2, l += 1) {
-	static scope_to_bits[] = {
+	static int scope_to_bits[] = {
 	  0,	/* UNKNOWN_SCOPE */
 	  4,	/* PUBLIC_SCOPE */
@@ -2033,5 +1868,5 @@ Object builtin_browser_class_parents(a)
     }
   }
-  
+
   free(list);
   accept_ctrl_c();
@@ -2039,29 +1874,28 @@ Object builtin_browser_class_parents(a)
 }
 
-Object builtin_browser_class_children(a)
+static Object builtin_browser_class_children(a)
     Instruction ** a;
 {
-  extern FCT(char **, get_sons_list,(char *));
-  char * class_name = (char *) Eval(a[0]);
+  const char *class_name = (const char *)Eval(a[0]);
   char ** list;
   char ** result = 0;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(class_name);
 #endif
-  
+
   ignore_ctrl_c();
   if ((list = get_sons_list(class_name)) != 0) {
     unsigned nentry;
     unsigned names_size = 0;
-    
+
     for (nentry = 0; list[nentry]; nentry += 1)
       names_size += strlen(list[nentry]) + 1;
-  
+
     result = (char **) RTCMalloc(sizeof(char*) * (nentry + 1) + names_size);
-    
+
     if (result) {
       char * p = (char *) &result[nentry + 1];
-      
+
       for (nentry = 0; list[nentry]; nentry += 1) {
 	result[nentry] = p;
@@ -2072,5 +1906,5 @@ Object builtin_browser_class_children(a)
     }
   }
-  
+
   free(list);
   accept_ctrl_c();
@@ -2078,20 +1912,19 @@ Object builtin_browser_class_children(a)
 }
 
-Object builtin_browser_class_methods(a)
+static Object builtin_browser_class_methods(a)
     Instruction ** a;
 {
-  FCT(extern StringTable*, get_methods_list,(char *, int));
   extern MethodRec* marked_list;
   extern int marked_count;
-  char * result = (char *) Eval(a[0]);
-  
+  const char *result = (const char *)Eval(a[0]);
+
 #ifdef RUNTIMECHECK
   check_strlen(result);
 #endif
-  
+
   ignore_ctrl_c();
   {
-    StringTable* x = get_methods_list(result, 0);
-    
+    StringTable x = get_methods_list(result, 0);
+
     if (x) {
       char * declfile = marked_list->_decl_file->_name;
@@ -2102,5 +1935,5 @@ Object builtin_browser_class_methods(a)
 
       free(x);
-      
+
       lastfile = declfile;
       i = marked_count;
@@ -2108,5 +1941,5 @@ Object builtin_browser_class_methods(a)
       while (i--) {
 	char * ifile;
-	
+
 	strsize += strlen(list->_name) + METHOD_PLENGTH + 1;
 	if (list->_impl_file &&
@@ -2118,5 +1951,5 @@ Object builtin_browser_class_methods(a)
 	list = list->_next_marked;
       }
-      if ((result = RTCMalloc((marked_count * 5 + 2) * sizeof(char *) + 
+      if ((result = RTCMalloc((marked_count * 5 + 2) * sizeof(char *) +
 			      strsize))
 	  != 0) {
@@ -2125,5 +1958,5 @@ Object builtin_browser_class_methods(a)
 	char * p;
 	unsigned index = 1;
-	
+
 	lastfile = declfile;
 	i = marked_count;
@@ -2134,5 +1967,5 @@ Object builtin_browser_class_methods(a)
 	while (i--) {
 	  char * ifile;
-	
+
 	  ((char **) result)[index] = p;
 	  strcpy(p, list->_name - METHOD_PLENGTH);
@@ -2159,5 +1992,5 @@ Object builtin_browser_class_methods(a)
 	  {
 	    MethodRec* next = list->_next_marked;
-	    
+
 	    list->_next_marked = 0;
 	    list = next;
@@ -2170,25 +2003,24 @@ Object builtin_browser_class_methods(a)
       result = 0;
   }
-  
+
   accept_ctrl_c();
   return (Object) result;
 }
 
-Object builtin_browser_class_attributes(a)
+static Object builtin_browser_class_attributes(a)
     Instruction ** a;
 {
-  FCT(extern StringTable*, get_attributes_list,(char *, int));
   extern AttributeRec* marked_attr_list;
   extern int marked_attr_count;
-  char * result = (char *) Eval(a[0]);
-  
+  const char *result = (const char *)Eval(a[0]);
+
 #ifdef RUNTIMECHECK
   check_strlen(result);
 #endif
-  
+
   ignore_ctrl_c();
   {
-    StringTable* x = get_attributes_list(result, 0);
-    
+    StringTable x = get_attributes_list(result, 0);
+
     if (x) {
       char * declfile = marked_attr_list->_decl_file->_name;
@@ -2198,5 +2030,5 @@ Object builtin_browser_class_attributes(
 
       free(x);
-      
+
       i = marked_attr_count;
       list = marked_attr_list;
@@ -2205,11 +2037,11 @@ Object builtin_browser_class_attributes(
 	list = list->_next_marked;
       }
-      
-      if ((result = RTCMalloc((marked_attr_count * 3 + 2) * sizeof(char *) + 
+
+      if ((result = RTCMalloc((marked_attr_count * 3 + 2) * sizeof(char *) +
 			      strsize))
 	  != 0) {
 	char * p = (char *) &((char **) result)[marked_attr_count * 3 + 2];
 	unsigned index = 1;
-	
+
 	i = marked_attr_count;
 	list = marked_attr_list;
@@ -2226,5 +2058,5 @@ Object builtin_browser_class_attributes(
 	  {
 	    AttributeRec* next = list->_next_marked;
-	    
+
 	    list->_next_marked = 0;
 	    list = next;
@@ -2237,15 +2069,14 @@ Object builtin_browser_class_attributes(
       result = 0;
   }
-  
+
   accept_ctrl_c();
   return (Object) result;
 }
 
-Object builtin_browser_class_flags(a)
+static Object builtin_browser_class_flags(a)
     Instruction ** a;
 {
-  extern FCT(char *, browser_class_flags,(char *));
-  char * class_name = (char *) Eval(a[0]);
-  
+  const char *class_name = (const char *)Eval(a[0]);
+
 #ifdef RUNTIMECHECK
   check_strlen(class_name);
@@ -2256,12 +2087,11 @@ Object builtin_browser_class_flags(a)
 }
 
-Object builtin_browser_functions(a)
+static Object builtin_browser_functions(a)
     Instruction ** a;
 {
-  extern FCT(ProcRec **, get_procs_list,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   ProcRec ** list;
   char ** result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2269,14 +2099,14 @@ Object builtin_browser_functions(a)
 
   ignore_ctrl_c();
-  if ((list = get_procs_list(prefix)) != 0) {
+  if ((list = get_procs_recs(prefix)) != 0) {
     ProcRec ** l;
     unsigned n;
     unsigned strsize = 0;
-    
+
     for (n = 0, l = list; *l; l += 1, n += 1) {
       strsize += strlen((*l)->_name) + PROC_PLENGTH + 1;
       if ((*l)->_impl_file) {
 	ProcRec ** sl;
-	
+
 	for (sl = list; sl != l; sl += 1)
 	  if ((*sl)->_impl_file &&
@@ -2290,5 +2120,5 @@ Object builtin_browser_functions(a)
 	!= 0) {
       char * p = (char *) &result[n * 3 + 1];
-      
+
       for (n = 0, l = list; *l; l += 1, n += 3) {
 	result[n] = p;
@@ -2297,5 +2127,5 @@ Object builtin_browser_functions(a)
 	if ((*l)->_impl_file) {
 	  unsigned i;
-	
+
 	  for (i = 0; i != n; i += 3)
 	    if (result[i + 1] &&
@@ -2319,17 +2149,16 @@ Object builtin_browser_functions(a)
   else
     result = 0;
-  
+
   accept_ctrl_c();
   return (Object) result;
 }
 
-Object builtin_browser_globals(a)
+static Object builtin_browser_globals(a)
     Instruction ** a;
 {
-  extern FCT(GlobalRec **, get_globals_list,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   GlobalRec ** list;
   char ** result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2337,14 +2166,14 @@ Object builtin_browser_globals(a)
 
   ignore_ctrl_c();
-  if ((list = get_globals_list(prefix)) != 0) {
+  if ((list = get_globals_recs(prefix)) != 0) {
     GlobalRec ** l;
     unsigned n;
     unsigned strsize = 0;
-    
+
     for (n = 0, l = list; *l; l += 1, n += 1) {
       strsize += strlen((*l)->_name) + GLOBAL_PLENGTH + 1;
       if ((*l)->_impl_file) {
 	GlobalRec ** sl;
-	
+
 	for (sl = list; sl != l; sl += 1)
 	  if ((*sl)->_impl_file &&
@@ -2358,5 +2187,5 @@ Object builtin_browser_globals(a)
 	!= 0) {
       char * p = (char *) &result[n * 3 + 1];
-      
+
       for (n = 0, l = list; *l; l += 1, n += 3) {
 	result[n] = p;
@@ -2365,5 +2194,5 @@ Object builtin_browser_globals(a)
 	if ((*l)->_impl_file) {
 	  unsigned i;
-	
+
 	  for (i = 0; i != n; i += 3)
 	    if (result[i + 1] &&
@@ -2387,16 +2216,15 @@ Object builtin_browser_globals(a)
   else
     result = 0;
-  
+
   accept_ctrl_c();
   return (Object) result;
 }
 
-Object builtin_browser_select_class(a)
+static Object builtin_browser_select_class(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_select_class,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2409,11 +2237,10 @@ Object builtin_browser_select_class(a)
 }
 
-Object builtin_browser_select_method(a)
+static Object builtin_browser_select_method(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_select_method,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2426,11 +2253,10 @@ Object builtin_browser_select_method(a)
 }
 
-Object builtin_browser_select_attribute(a)
+static Object builtin_browser_select_attribute(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_select_attribute,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2443,11 +2269,10 @@ Object builtin_browser_select_attribute(
 }
 
-Object builtin_browser_select_function(a)
+static Object builtin_browser_select_function(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_select_proc,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2460,11 +2285,10 @@ Object builtin_browser_select_function(a
 }
 
-Object builtin_browser_select_global(a)
+static Object builtin_browser_select_global(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_select_global,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2477,10 +2301,8 @@ Object builtin_browser_select_global(a)
 }
 
-Object builtin_browser_edit(a)
-    Instruction ** a;
+static Object builtin_browser_edit(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ButtonEdit,());
-  extern FCT(void, DisplayBrowserIfNeverMap,());
-  
+
   ignore_ctrl_c();
   DisplayBrowserIfNeverMap();
@@ -2490,11 +2312,10 @@ Object builtin_browser_edit(a)
 }
 
-Object builtin_browser_class_entry(a)
+static Object builtin_browser_class_entry(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_class_entry,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2507,11 +2328,10 @@ Object builtin_browser_class_entry(a)
 }
 
-Object builtin_browser_function_entry(a)
+static Object builtin_browser_function_entry(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_function_entry,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2524,11 +2344,10 @@ Object builtin_browser_function_entry(a)
 }
 
-Object builtin_browser_global_entry(a)
+static Object builtin_browser_global_entry(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_global_entry,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2541,11 +2360,10 @@ Object builtin_browser_global_entry(a)
 }
 
-Object builtin_browser_file_entry(a)
+static Object builtin_browser_file_entry(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_file_entry,(char *));
-  char * prefix = (char *) Eval(a[0]);
+  const char *prefix = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(prefix);
@@ -2558,51 +2376,46 @@ Object builtin_browser_file_entry(a)
 }
 
-Object builtin_browser_class(a)
+static Object builtin_browser_class(a)
     Instruction ** a;
 {
-  extern FCT(char *, browser_class,(int));
   int n = (int) Eval(a[0]);
-  
+
   ignore_ctrl_c();
   return strdup_end(browser_class(n));
 }
 
-Object builtin_browser_function(a)
+static Object builtin_browser_function(a)
     Instruction ** a;
 {
-  extern FCT(char *, browser_function,(int));
   int n = (int) Eval(a[0]);
-  
+
   ignore_ctrl_c();
   return strdup_end(browser_function(n));
 }
 
-Object builtin_browser_global(a)
+static Object builtin_browser_global(a)
     Instruction ** a;
 {
-  extern FCT(char *, browser_global,(int));
   int n = (int) Eval(a[0]);
-  
+
   ignore_ctrl_c();
   return strdup_end(browser_global(n));
 }
 
-Object builtin_browser_file(a)
+static Object builtin_browser_file(a)
     Instruction ** a;
 {
-  extern FCT(char *, browser_file,(int));
   int n = (int) Eval(a[0]);
-  
+
   ignore_ctrl_c();
   return strdup_end(browser_file(n));
 }
 
-Object builtin_browser_dump(a)
+static Object builtin_browser_dump(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_dump,(char *));
-  char * fn = (char *) Eval(a[0]);
+  const char *fn = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(fn);
@@ -2612,15 +2425,14 @@ Object builtin_browser_dump(a)
   result = (Object) browser_dump(fn);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_browser_restore(a)
+static Object builtin_browser_restore(a)
     Instruction ** a;
 {
-  extern FCT(int, browser_restore,(char *));
-  char * fn = (char *) Eval(a[0]);
+  const char *fn = (const char *)Eval(a[0]);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(fn);
@@ -2630,19 +2442,17 @@ Object builtin_browser_restore(a)
   result = (Object) browser_restore(fn);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_browser_show_all(a)
-    Instruction ** a;
+static Object builtin_browser_show_all(a)
+    Instruction **a __attribute__((unused));
 {
-  extern FCT(void, browser_show_all,());
-  extern FCT(void, RefreshBrowserInfos,());
-  
+
   ignore_ctrl_c();
   browser_show_all();
   RefreshBrowserInfos();
   accept_ctrl_c();
-  
+
   return 0;
 }
